//Keyboard scan
#include <avr/io.h>
#include <inttypes.h>
#include "BooleConst.h"
#include "Keyboard_def.h"
#include "Keyboard_hlr.h"

volatile unsigned char KeyScanEnabled;

#ifdef BT1
static volatile uint8_t BT1_new;
static volatile uint8_t BT1_old;
static volatile uint8_t BT1_pressed;
#endif

#ifdef BT2
static volatile uint8_t BT2_new;
static volatile uint8_t BT2_old;
static volatile uint8_t BT2_pressed;
#endif

#ifdef BT3
static volatile uint8_t BT3_new;
static volatile uint8_t BT3_old;
static volatile uint8_t BT3_pressed;
#endif

#define key_buff_size 4
static volatile int Key_timcnt;
static volatile unsigned char key_buff[key_buff_size];
static volatile unsigned char *keybuffp;
static volatile unsigned char key_wr;
static volatile unsigned char key_rd;
static volatile unsigned char key_num;
static volatile unsigned int repeat_delay_cnt;
static volatile unsigned int repeat_time_cnt;

#define InitKeyScan Key_timcnt = KeyScanTime;


void KeyCodeToBuffer(uint8_t KeyCode)
{
			*(keybuffp + key_wr) = KeyCode;
			key_wr = (key_wr + 1) % key_buff_size;
			if(key_num < key_buff_size)
			{
				key_num++;
			}
			else
			{
				key_rd = key_wr;
			}	
}
	

void KScan(void)
{
		#ifdef BT1
		BT1_new = ~BT1PIN & BT1;
		BT1_pressed = BT1_new & ~BT1_old;
				
		if(BT1_pressed)
		{
			repeat_delay_cnt = 0;				// init repeat_delay_cnt
			KeyCodeToBuffer(KBT1);
		}
		else if(BT1_new & BT1_old)								//if pressed before...
			{				
				if(repeat_delay_cnt < repeat_delay_)				
				{
					repeat_delay_cnt++;
					repeat_time_cnt = 0;
				}
				else
				{												// if repeat_delay finished
					if(repeat_time_cnt < repeat_time_)
					{
						repeat_time_cnt++;
					}
					else
					{											// if repeat time finished
						KeyCodeToBuffer(KBT1);
						repeat_time_cnt = 0;
					}
				}
			}
		BT1_old = BT1_new;	
		#endif
		
		#ifdef BT2
		BT2_new = ~BT2PIN & BT2;
		BT2_pressed = BT2_new & ~BT2_old;
		
		if(BT2_pressed)
		{
			repeat_delay_cnt = 0;				// init repeat_delay_cnt
			KeyCodeToBuffer(KBT2);
		}
		else if(BT2_new & BT2_old)								//if pressed before...
		{
			if(repeat_delay_cnt < repeat_delay_)
			{
				repeat_delay_cnt++;
				repeat_time_cnt = 0;
			}
			else
			{												// if repeat_delay finished
				if(repeat_time_cnt < repeat_time_)
				{
					repeat_time_cnt++;
				}
				else
				{											// if repeat time finished
					KeyCodeToBuffer(KBT2);
					repeat_time_cnt = 0;
				}
			}
		}
		BT2_old = BT2_new;
		#endif

		#ifdef BT3
		BT3_new = ~BT3PIN & BT3;
		BT3_pressed = BT3_new & ~BT3_old;
		
		if(BT3_pressed)
		{
			repeat_delay_cnt = 0;				// init repeat_delay_cnt
			KeyCodeToBuffer(KBT3);
		}
		else if(BT3_new & BT3_old)								//if pressed before...
		{
			if(repeat_delay_cnt < repeat_delay_)
			{
				repeat_delay_cnt++;
				repeat_time_cnt = 0;
			}
			else
			{												// if repeat_delay finished
				if(repeat_time_cnt < repeat_time_)
				{
					repeat_time_cnt++;
				}
				else
				{											// if repeat time finished
					KeyCodeToBuffer(KBT3);
					repeat_time_cnt = 0;
				}
			}
		}
		BT3_old = BT3_new;
		#endif								
}

/*
void KScan(void)
{
	#ifdef BT1
	BT1_new = ~BT1PIN & BT1;
	BT1_pressed = BT1_new & ~BT1_old;
	BT1_old = BT1_new;
	if(BT1_pressed)
	{
		*(keybuffp + key_wr) = KBT1;
		key_wr = (key_wr + 1) % key_buff_size;
		if(key_num < key_buff_size)
		{
			key_num++;
		}
		else
		{
			key_rd = key_wr;
		}
	}
	#endif
	
	#ifdef BT2
	BT2_new = ~BT2PIN & BT2;
	BT2_pressed = BT2_new & ~BT2_old;
	BT2_old = BT2_new;
	if(BT2_pressed)
	{
		*(keybuffp + key_wr) = KBT2;
		key_wr = (key_wr + 1) % key_buff_size;
		if(key_num < key_buff_size)
		{
			key_num++;
		}
		else
		{
			key_rd = key_wr;
		}
	}
	#endif

	#ifdef BT3
	BT3_new = ~BT3PIN & BT3;
	BT3_pressed = BT3_new & ~BT3_old;
	BT3_old = BT3_new;
	if(BT3_pressed)
	{
		*(keybuffp + key_wr) = KBT3;
		key_wr = (key_wr + 1) % key_buff_size;
		if(key_num < key_buff_size)
		{
			key_num++;
		}
		else
		{
			key_rd = key_wr;
		}
	}
	#endif
}
*/
void KeyScan(void)
{
	if(KeyScanEnabled)
	{
		if(Key_timcnt > 0) Key_timcnt--;
		else
		{
			;InitKeyScan;
			KScan();
		}
	}

}


void KeyInit(void)
{
	InitKeyScan;
	#ifdef BT1PORT
	BT1PORT |= BT1;
	BT1_old = ~BT1PIN & BT1;
	#endif
	#ifdef BT2PORT
	BT2PORT |= BT2;
	BT2_old = ~BT2PIN & BT2;	
	#endif
	#ifdef BT3PORT
	BT3PORT |= BT3;
	BT3_old = ~BT3PIN & BT3;
	#endif	
	keybuffp = &key_buff[0];
	key_wr = 0;
	key_rd = 0;
	key_num = 0;
}


unsigned char KeyPressed(unsigned char *k_code)
{
	if(key_num)
	{
		*k_code = *(key_buff + key_rd);	//copy value
		key_rd = (key_rd + 1) % key_buff_size;
		key_num--;
		return(TRUE);

	}
	else
	{
		return(FALSE);
	}
}
