
// sample program of TIMER0 normal mode, cycle decrasing by sw counter (C) Z. Benesoczky
// peripheral handling by polling

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>

//#include <avr/signal.h>

// SYS CLK = 8MHz (125nsec)
//use TIMER0
//          D7     D6     D5     D4    D3    D2    D1     D0
//TCCR0A: COM0A1 COM0A0 COM0B1 COM0B0  -     -    WGM01  WGM00
//           0      0      0      0    0     0      0      0

//          D7     D6     D5     D4    D3    D2    D1     D0
//TCCR0B: A FC0A FC0B     -      -    WGM02  CS2   CS1   CS0
//           0     0      0      0      0     1     0     1
//normal mode, div=1024 (7812.5 Hz)

#define tim0_modeA 0x00
#define tim0_modeB 0x05

//LED on PORTA(7)
#define LED_mask  1 << 5

char timcnt;
char timcnt0;


void TIMER0_Init(void)
{
	TCCR0A = tim0_modeA;
	TCCR0B = tim0_modeB;
}


unsigned char TimerSignal(void)
{
	unsigned char tmp;

	tmp = 0;
	if(TIFR0 & (1<<TOV0))
	{
		TIFR0 = TIFR0 | (1<<TOV0); // clear TOV0
		TCNT0 = 0x7F;	//reload counter to shorter the cycle  7812,5/128 = 61Hz

		if (timcnt>0)
		{
			timcnt-=1;
		}
		else
		{
			timcnt = timcnt0;
			tmp = 1;
		}
	}

	return(tmp);
}

int main(void)
{
	
	DDRB = LED_mask;
	TIMER0_Init();
	timcnt0 = 60; // 0-60: 61 state
	//sei();
	do
	{
		if(TimerSignal())
		{
			PORTB = PORTB ^ LED_mask;
		}

	}while(1);
}

