
// sample program for TIMER0 CTC mode (auto reload)
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>


// SYS CLK = 8MHz (125nsec)
//use TIMER0
//          D7     D6     D5     D4    D3    D2    D1     D0
//TCCR0A: COM0A1 COM0A0 COM0B1 COM0B0  -     -    WGM01  WGM00
//           0      0      0      0    0     0      1      0

//          D7     D6     D5     D4    D3    D2    D1     D0
//TCCR0B: A FC0A FC0B     -      -    WGM02  CS2   CS1   CS0
//           0     0      0      0      0     1     0     1
//CTC mode, div=1024 (7812.5 Hz)

#define tim0_modeA 0x02
#define tim0_modeB 0x05

//LED on PORTB(5)
#define LED_mask  1 << 5

char timcnt;
char timcnt0;

void TIMER0_Init(void)
{
	TCCR0A = tim0_modeA;
	TCCR0B = tim0_modeB;
	OCR0A = 0x7F;  //f = 8MHz/(1024*128) = 61 Hz (65ms)	
	TIMSK0 =  TIMSK0 | (1 << OCIE0A); // output compare IT enabled
}


// Timer0 compare IT
ISR(TIMER0_COMPA_vect)
{
	if (timcnt>0)
	{
		timcnt-=1;
	}
	else
	{
		timcnt = timcnt0;
		//PORTB = PORTB ^ LED_mask;
		PINB = LED_mask;
	}
}


int main(void)
{
	
	DDRB = LED_mask;
	TIMER0_Init();
	timcnt0 = 61;
	sei();
	while(1);
}

