/*
 * EEPROM_samp.c
 *
 * Created: 5/3/2015 1:04:39 PM
 *  Author: Zoltan
 */ 

#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include "proj_inc.h"

void InitCard(void)
{
	LCD_init();
	TIMER0_Init();
	KeyInit();
	EEPROM_Init();
}

#define ee_addr 0
#define ee_rd_pos 0
#define ee_wr_pos 7

unsigned char EEMEM EE_var0 = 0x00;	// init EEPROM when programmming the chip
unsigned char EEMEM EE_var1 = 0x01;	
unsigned char EEMEM EE_var2 = 0x02;

int main(void)
{
	char but;
	unsigned int rd_data;
	unsigned char wr_data;
		
	InitCard();
	sei();
	wr_data = EEPROM_RD(ee_addr);
	LCD_write_str_pos("EE rd: EE wr: ", line1, 0);
	LCD_write_int_pos((int)wr_data, line2, ee_wr_pos);
	StartTime0(100);
    while(1)
    {	
		if(Time0Done())
		{
			rd_data = EEPROM_RD(ee_addr);
			LCD_write_int_pos(rd_data, line2, ee_rd_pos);
			StartTime0(100);			
		}
		if(KeyPressed(&but))
		{
			switch(but)
			{
				case KBT1:
					EEPROM_WR_START(&wr_data,ee_addr,1);
					break;
				case KBT2:
					wr_data--;
					LCD_write_int_pos((int)wr_data, line2, ee_wr_pos);
					break;
				case KBT3:
					wr_data++;
					LCD_write_int_pos((int)wr_data, line2, ee_wr_pos);
					break;
				default:
					break;
			}
		}
    }
}
