// **** UART MINTA PROGRAM ****

// konyvtar header file-ok
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>
#include "proj_inc.h"

// konstans definiciok

//#define CLK (long)16000000 /* MHz/10 */
#define CLK (long)8000000 //MHz
#define BAUD (long)9600	//Baud
//#define BAUD (long)115200	//Baud

#define UBRR_VALUE  (unsigned int)((CLK/(16*BAUD)-1) & 0x0fff)

// globalis valtozo deklaraciok
//static unsigned char  SER_DAT[64];
//unsigned char *pSERDAT;

#define CR 0x0d

//remote commands:
//test of serial line
#define TEST	't'
//hexbyte
#define XBYTE	'b'
//hexword
#define XWORD	'w'
//double (float)
#define XDOUBLE 'd'
// get integer value
#define SendInt  's'

int GetInteger(void)
{	unsigned char data;
	char intstr[8];
	int i = 0;
	do{
		do{}while(!GET_UART(&data));
		if((data == CR) | (i > 5))
		{
			 break;
		}
		else
		{
			intstr[i] = data;
			i++;
		}
	}while(1);
	intstr[i] = 0;
	return (atoi(intstr));
}


void sysinit(void)
{
	LCD_init();
	TIMER0_Init();
	USART0_Init(UBRR_VALUE,simple_speed);
	sei(); // IT enable
	LCD_light(0);
}


int main(void)
{
	unsigned char UART_data;
	char str[16];
	double d_var;
	int int_var;
	sysinit();
	LCD_write_str("  UART sample   ",line1);
	while(1)
	{
	if (GET_UART(&UART_data))
		{
			switch(UART_data)
			{
			case TEST:	SerouString("UART sample\r\n");
						LCD_write_str("  UART sample   ",line2);
						break;
			case XBYTE:	sout_hexbyte(0x12);
						SerouString(" ");
						LCD_write_int_pos(0x12,line2,0);
						break;
			case XWORD:	sout_hexword(0x1234);
						SerouString(" ");
						LCD_write_int_pos(0x1234,line2,0);
						break;
			case XDOUBLE: d_var = -1.234e5;						
						dtostre(d_var, str,3,0);
						strcat(str," ");
						SerouString(str);
						//LCD_write_str(str,line2);						
						LCD_write_double_pos(d_var,8,0,line2,0);
						break;					
			case SendInt:
						int_var = GetInteger();
						itoa(int_var,str,10);
						strcat(str," ");
						SerouString(str);
						LCD_write_str(str,line2);
						unsigned char brightness = (unsigned char)(int_var & 0x000f);
						LCD_light(brightness);
						break;																						
			default:	SerouString(" Undefined command!\r\n");
						CrLf();
						break;			
			}
		}
	}
}
