// **** UART MINTA PROGRAM ****

// konyvtar header file-ok
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include <stdlib.h>
#include "proj_inc.h"

// konstans definiciok

#define BAUD (long)9600	//Baud
//#define BAUD (long)115200	//Baud

#define UBRR_VALUE  (unsigned int)((Fcpu/(16*BAUD)-1) & 0x0fff)

// globalis valtozo deklaraciok
//static unsigned char  SER_DAT[64];
//unsigned char *pSERDAT;

#define CR 0x0d

//remote commands:
//test of serial line
#define TEST	't'
//hexbyte
#define XBYTE	'b'
//hexword
#define XWORD	'w'
//double (float)
#define XDOUBLE 'd'
// get integer value
#define SendInt 's'

#define GetIntTimeMax 100
#define IntCharMax 5
//get characters of integer value, till carrige return
//In case of error, return value = 1
//integer value return in intvalue
int GetInteger(int * intvalue)
{	unsigned char data;
	char intstr[8];
	int i = 0;
	unsigned char GetIntErr, timeout;
	
	GetIntErr = 0;
	StartTime0(GetIntTimeMax);	// 
	do{
		do{
			timeout = Time0Done();
			}while(!(GET_UART(&data) | timeout));
		
		GetIntErr += (i > IntCharMax) | timeout;	
		
		if((data == CR) | timeout)
		{
			 break;
		}
		else
		{
			if((data >= '0') && (data <= '9'))		//valid decimal numbers?
			{
				intstr[i] = data;
				i++;
			}
			else
			{
				GetIntErr += 1;		//not valid numbers!
			}
		}
	}while(1);
	
	if(GetIntErr)
	{
		return(0);
	}
	else
	{
		if(i==0)
		{
			return(0);	//no numbers received!
		}
		else
		{
			intstr[i] = 0;
			*intvalue = atoi(intstr);
			return(1);			
		}

	}
}


void sysinit(void)
{
	LCD_init();
	TIMER0_Init();
	USART0_Init(UBRR_VALUE,simple_speed);
	sei(); // IT enable
	LCD_light(0);
}


int main(void)
{
	unsigned char UART_data;
	char str[16];
	double d_var;
	int i_var,brightness;
	sysinit();
	LCD_write_str("  UART sample   ",line1);
	while(1)
	{
	if (GET_UART(&UART_data))
		{
			switch(UART_data)
			{
			case TEST:	SerouString("UART sample\r\n");
						LCD_write_str("  UART sample   ",line2);
						break;
			case XBYTE:	sout_hexbyte(0x12);
						SerouString(" ");
						LCD_write_str("                ",line2);
						LCD_write_int_pos(0x12,line2,0);
						break;
			case XWORD:	sout_hexword(0x1234);
						SerouString(" ");
						LCD_write_str("                ",line2);
						LCD_write_int_pos(0x1234,line2,0);
						break;
			case XDOUBLE: d_var = -1.234e5;						
						dtostre(d_var, str,3,0);
						strcat(str," ");
						SerouString(str);
						//LCD_write_str(str,line2);
						LCD_write_str("                ",line2);						
						LCD_write_double_pos(d_var,8,0,line2,0);
						break;					
			case SendInt:
						if(GetInteger(&i_var))
						{
							LCD_write_str("                ",line2);
							LCD_write_int_pos(i_var, line2, 0);

							if((i_var >= 0)&&(i_var <= 15))
							{
								brightness = i_var;
								LCD_light(brightness);		
							}						
						}
						else
						{
							LCD_write_str("                ",line2);
							LCD_write_str("Parameter Error!", line2);
							SerouString(" Parameter Error!\r\n");
						}
						break;																						
			default:	SerouString(" Undefined command!\r\n");
						CrLf();
						break;			
			}
		}
	}
}
