/*
 * SPI_LCD
 *
 * Created: 1/31/2015 11:52:51 PM
 *  Author: Zoltan Benesoczky
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>
#include "proj_inc.h"

void InitCard(void)
{
	TIMER0_Init();
	LCD_init();
	KeyInit();
	sei();
}

int main(void)
{
	volatile uint8_t bright, old_bright;
	unsigned char key;
	
	InitCard();
	bright = 0;
	LCD_light(bright);
	LCD_write_str("    LCD demo    ", line1);
	LCD_write_str("brightness: ", line2);
	unsigned char bright_pos = strlen("brightness: ");
	LCD_write_int_pos(bright, line2, bright_pos);
	
    while(1)
    {			
		if(KeyPressed(&key))
		{
			switch(key)
			{
			case KBT1:							
				bright = 0;
				break;
			case KBT3:
				if(bright < 15)
				{
					old_bright = bright;
					bright = (bright + 1);					
				}
				break;
			case KBT2:
				if(bright > 0)
				{
					old_bright = bright;
					bright = (bright - 1);
				}
				break;				
			}
			
			LCD_light(bright);

			LCD_write_str_pos(" ", line1, old_bright);
			LCD_write_str_pos("|", line1, bright);
			
			LCD_write_str_pos("  ", line2, bright_pos);
			LCD_write_int_pos(bright, line2, bright_pos);
			
			// Testing to interfere with each other in the course of this communication
			WaitForSPI();
			SPI_Busy = TRUE;
			SPI_MasterTransmit(0x00);
			SPI_Busy = FALSE;			
		}		
    }	
}