/*
 * ADC_sample.c
 *
 * Created: 4/12/2015 2:46:42 PM
 *  Author: Zoltan
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include "proj_inc.h"

float RefValue;
unsigned char RefSelect;
void InitCard(void)
{
	TIMER0_Init();
	KeyInit();
	LCD_init();
	RefSelect = Ref_1V1;
	RefValue = 1.1;
	/*
	RefSelect = Ref_AVCC;
	RefValue = 3.3;
	*/
	ADC_Init(RefSelect, ADC_Temp, Trg_FreeRun, fdiv_128, 1);	
	DIDR0 = 0x01;
	sei();
}

#define ModeVolt 1
#define ModeTemp 2

int main(void)
{
	#define DpyRfshTime 500
	double AD_value;
	unsigned char mode,key;
	InitCard();
	
	mode = ModeVolt;
	LCD_write_str_pos("ADC sample",line1, 3);
	StartTime0(DpyRfshTime); 
    while(1)
    {
		if(KeyPressed(&key))
		{
			if(mode == ModeVolt)
			{
				mode = ModeTemp;
			}
			else
			{
				mode = ModeVolt;
			}
		}
		

		if( Get_ADC_Voltage(&AD_value,RefValue))
		{
			if(Time0Done())
			{
				LCD_write_double_pos(AD_value,5,3,line2,0);
				StartTime0(DpyRfshTime);
			}			 
		}
    }
}